class CollectionsController < ApplicationController
  before_action :set_collection, only: [:show, :update, :destroy, :like]

  # GET /collections
  # GET /collections.json
  def index
    @collections = collection_repository.all
  end

  # GET /collections/1
  # GET /collections/1.json
  def show
  end

  # POST /collections/1/like
  def like
    collection_repository.like @collection
  end

  # POST /collections
  # POST /collections.json
  def create
    @collection = Collection.new(collection_params)

    respond_to do |format|
      if collection_repository.save @collection
        format.html { redirect_to @collection, notice: 'Collection was successfully created.' }
      else
        format.html { render :new }
      end
    end
  end

  # PATCH/PUT /collections/1
  # PATCH/PUT /collections/1.json
  def update
    respond_to do |format|
      if collection_repository.update(collection_params)
        format.html { redirect_to @collection, notice: 'Collection was successfully updated.' }
      else
        format.html { render :edit }
      end
    end
  end

  # DELETE /collections/1
  # DELETE /collections/1.json
  def destroy
    collection_repository.destroy @collection

    respond_to do |format|
      format.html { redirect_to collections_url, notice: 'Learning object was successfully destroyed.' }
    end
  end

  private

  def set_collection
    @collection = collection_repository.find params[:id]
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def collection_params
    params.require(:collection).permit(:name, :privacy, learning_objects: [])
  end

end
