class SearchController < ApplicationController

  include SearchEngine::OrientdbLucene

  def index

    objectsFound = search(params[:qry])
    @numFound = objectsFound.length

    per_page=10
    @npagnac=10
    if(params[:paginacao])
      per_page=params[:paginacao].to_i
      @npagnac=per_page
    end

    if(params[:page])
      #params[:page] = 1
    else
      params[:page] = 1
    end

    current_page = params[:page].to_i

    if params[:sort]
      @ordena = params[:sort]
    end
    if params[:sort] == "author"
      objectsFound = sort_author(objectsFound);
    elsif params[:sort] == "publicationasc"
      objectsFound = objectsFound.sort_by{|item| [ item.id ]}
    elsif params[:sort] == "publicationdesc"
      objectsFound = objectsFound.sort_by{|item| - item.id }
    elsif params[:sort] == "relevance"
      items= objectsFound.collect{ |x| Ranking::Item.new(x.name,x.views,0,x.likes,x)  } #puts each object in an item

      rater = Ranking::Rater.new(
          Ranking::Strategies::BasicRater.new(
              #define sorting weights
              positionWeight = 1000,
              useWeight = 1,
              likeWeight = 100
          )
      )

      a = rater.sortByRate(items) # Returns sorted array of items
      objectsFound = a.collect{ |x|  x.info  } #get only the info fields(objects)

    elsif params[:sort] == "title"
      objectsFound = sort_title(objectsFound);
    end
    #    current_page, per_page, total_results
    @results = WillPaginate::Collection.create(current_page, per_page, objectsFound.length) do |pager|
      @start = (current_page-1)*per_page
      pager.replace (objectsFound.to_a[@start,per_page])
    end

  end

  private

  def sort_author(items)
    # items = items.sort_by{|item| [ item['author'].to_s.downcase ]}
    # items.each{ |item| item['author'] = sort_author(item['author']) if (item['author'].nil? ? [] : item['author']).size > 0 }
    items
  end


  def sort_title(items)
    # items = items.sort_by{|item| [ item['title'].to_s.downcase ]}
    # items.each{ |item| item['title'] = sort_title(item['title']) if (item['title'].nil? ? [] : item['title']).size > 0 }
    items
  end
end
